concepts.hpp File Reference

## Classes

struct | concepts::detail::ignore
struct | concepts::detail::Nil
struct | concepts::return_t_< typename >

## Macros

#define | CPP_and &&
#define | CPP_and_sfinae && CPP_BOOL(CPP_true), int> = 0, std::enable_if_t<
#define | CPP_and_sfinae_def && CPP_BOOL(CPP_true), int>, std::enable_if_t<
#define | CPP_assert(...)
#define | CPP_assert_msg static_assert
#define | CPP_auto_fun(X) X CPP_AUTO_FUN_IMPL_
#define | CPP_AUTO_FUN_DECLTYPE_NOEXCEPT_(...)
| INTERNAL ONLY. More...
#define | CPP_AUTO_FUN_IMPL_(...) (__VA_ARGS__) CPP_AUTO_FUN_RETURNS_
| INTERNAL ONLY.
#define | CPP_AUTO_FUN_RETURNS_(...)
| INTERNAL ONLY. More...
#define | CPP_AUTO_FUN_RETURNS_CONST_0(...)
| INTERNAL ONLY. More...
#define | CPP_AUTO_FUN_RETURNS_CONST_1(...) __VA_ARGS__ CPP_AUTO_FUN_RETURNS_CONST_0
| INTERNAL ONLY.
#define | CPP_AUTO_FUN_RETURNS_CONST_2(...) CPP_PP_CAT(CPP_PP_EAT_MUTABLE_, __VA_ARGS__) CPP_AUTO_FUN_RETURNS_CONST_0
| INTERNAL ONLY.
#define | CPP_AUTO_FUN_RETURNS_return
| INTERNAL ONLY.
#define | CPP_AUTO_FUN_SELECT_RETURNS_(MAYBE_CONST, ...)
| INTERNAL ONLY. More...
#define | CPP_BOOL(...) __VA_ARGS__
#define | CPP_broken_friend_ret(...) __VA_ARGS__ CPP_PP_EXPAND
#define | CPP_concept META_CONCEPT
#define | CPP_CONCEPT_NAME_(DECL)
| INTERNAL ONLY. More...
#define | CPP_CONCEPT_PARAMS_(DECL) CPP_PP_EVAL(CPP_PP_SECOND, CPP_EAT_CONCEPT_(DECL))
| INTERNAL ONLY.
#define | CPP_concept_ref(NAME, ...) CPP_PP_CAT(NAME, _concept_)<__VA_ARGS__>
#define | CPP_ctor(TYPE) TYPE CPP_CTOR_IMPL_1_
#define | CPP_CTOR_IMPL_1_(...) (__VA_ARGS__) CPP_CTOR_IMPL_2_
| INTERNAL ONLY.
#define | CPP_CTOR_IMPL_2_(...) __VA_ARGS__ `
#define | CPP_ctor_sfinae(TYPE)
#define | CPP_CTOR_SFINAE_EAT_NOEXCEPT_noexcept(...)
| INTERNAL ONLY.
#define | CPP_CTOR_SFINAE_IMPL_1_(...)
| INTERNAL ONLY. More...
#define | CPP_CTOR_SFINAE_MAKE_PROBE(FIRST, ...) CPP_PP_CAT(CPP_CTOR_SFINAE_PROBE_NOEXCEPT_, FIRST)
| INTERNAL ONLY.
#define | CPP_CTOR_SFINAE_PROBE_NOEXCEPT_noexcept CPP_PP_PROBE(~)
| INTERNAL ONLY.
#define | CPP_CTOR_SFINAE_REQUIRES(...)
| INTERNAL ONLY. More...
#define | CPP_CTOR_SFINAE_REQUIRES_0(...)
| INTERNAL ONLY. More...
#define | CPP_CTOR_SFINAE_REQUIRES_1(...)
| INTERNAL ONLY. More...
#define | CPP_CTOR_SFINAE_SHOW_NOEXCEPT_noexcept(...)
| INTERNAL ONLY. More...
#define | CPP_CXX_CONCEPTS 201800L
#define | CPP_CXX_VA_OPT 0
#define | CPP_EAT_CONCEPT_(DECL) CPP_PP_CAT(CPP_EAT_CONCEPT_, DECL)
| INTERNAL ONLY.
#define | CPP_EAT_CONCEPT_concept
| INTERNAL ONLY.
#define | CPP_fun(X) X CPP_FUN_IMPL_1_
#define | CPP_FUN_IMPL_1_(...)
| INTERNAL ONLY. More...
#define | CPP_FUN_IMPL_2_(...) __VA_ARGS__ `
#define | CPP_member
#define | CPP_member_sfinae CPP_broken_friend_member
#define | CPP_NOT(...) (!(__VA_ARGS__))
#define | CPP_PP_CAT(X, ...) CPP_PP_CAT_(X, __VA_ARGS__)
#define | CPP_PP_CAT_(X, ...) X ## __VA_ARGS__
#define | CPP_PP_CHECK(...) CPP_PP_EXPAND(CPP_PP_CHECK_N(__VA_ARGS__, 0,))
#define | CPP_PP_CHECK_N(x, n, ...) n
#define | CPP_PP_COMMA() ,
#define | CPP_PP_COMMA_IIF(X) CPP_PP_IIF(X)(CPP_PP_EMPTY, CPP_PP_COMMA)()
#define | CPP_PP_COUNT(...)
#define | CPP_PP_COUNT_( _01, _02, _03, _04, _05, _06, _07, _08, _09, _10, _11, _12, _13, _14, _15, _16, _17, _18, _19, _20, _21, _22, _23, _24, _25, _26, _27, _28, _29, _30, _31, _32, _33, _34, _35, _36, _37, _38, _39, _40, _41, _42, _43, _44, _45, _46, _47, _48, _49, _50, N, ...) N
#define | CPP_PP_EAT(...)
#define | CPP_PP_EAT_MUTABLE_mutable
| INTERNAL ONLY.
#define | CPP_PP_EMPTY()
#define | CPP_PP_EVAL(X, ...) CPP_PP_EVAL_(X, (__VA_ARGS__))
#define | CPP_PP_EVAL2(X, ...) CPP_PP_EVAL2_(X, (__VA_ARGS__))
#define | CPP_PP_EVAL2_(X, ARGS) X ARGS
#define | CPP_PP_EVAL_(X, ARGS) X ARGS
#define | CPP_PP_EXPAND(...) __VA_ARGS__
#define | CPP_PP_FIRST(LIST) CPP_PP_FIRST_ LIST
#define | CPP_PP_FIRST_(...) __VA_ARGS__ CPP_PP_EAT
#define | CPP_PP_FOR_EACH(M, ...) CPP_PP_FOR_EACH_N(CPP_PP_COUNT(__VA_ARGS__), M, __VA_ARGS__)
#define | CPP_PP_FOR_EACH_1(M, _1) M(_1)
#define | CPP_PP_FOR_EACH_2(M, _1, _2) M(_1), M(_2)
#define | CPP_PP_FOR_EACH_3(M, _1, _2, _3) M(_1), M(_2), M(_3)
#define | CPP_PP_FOR_EACH_4(M, _1, _2, _3, _4) M(_1), M(_2), M(_3), M(_4)
#define | CPP_PP_FOR_EACH_5(M, _1, _2, _3, _4, _5) M(_1), M(_2), M(_3), M(_4), M(_5)
#define | CPP_PP_FOR_EACH_6(M, _1, _2, _3, _4, _5, _6) M(_1), M(_2), M(_3), M(_4), M(_5), M(_6)
#define | CPP_PP_FOR_EACH_7(M, _1, _2, _3, _4, _5, _6, _7) M(_1), M(_2), M(_3), M(_4), M(_5), M(_6), M(_7)
#define | CPP_PP_FOR_EACH_8(M, _1, _2, _3, _4, _5, _6, _7, _8) M(_1), M(_2), M(_3), M(_4), M(_5), M(_6), M(_7), M(_8)
#define | CPP_PP_FOR_EACH_N(N, M, ...) CPP_PP_CAT(CPP_PP_FOR_EACH_, N)(M, __VA_ARGS__)
#define | CPP_PP_IGNORE_CXX2A_COMPAT_BEGIN
#define | CPP_PP_IGNORE_CXX2A_COMPAT_END
#define | CPP_PP_IIF(BIT) CPP_PP_CAT_(CPP_PP_IIF_, BIT)
#define | CPP_PP_IIF_0(TRUE, ...) __VA_ARGS__
#define | CPP_PP_IIF_1(TRUE, ...) TRUE
#define | CPP_PP_IS_NOT_EMPTY(...)
#define | CPP_PP_IS_PAREN(x) CPP_PP_CHECK(CPP_PP_IS_PAREN_PROBE x)
#define | CPP_PP_IS_PAREN_PROBE(...) CPP_PP_PROBE(~)
#define | CPP_PP_LBRACE() {
#define | CPP_PP_LPAREN (
#define | CPP_PP_NOT(BIT) CPP_PP_CAT_(CPP_PP_NOT_, BIT)
#define | CPP_PP_NOT_0 1
#define | CPP_PP_NOT_1 0
#define | CPP_PP_PROBE(x) x, 1,
#define | CPP_PP_PROBE_CONST_MUTABLE_PROBE_const CPP_PP_PROBE_N(~, 1)
| INTERNAL ONLY.
#define | CPP_PP_PROBE_CONST_MUTABLE_PROBE_mutable CPP_PP_PROBE_N(~, 2)
| INTERNAL ONLY.
#define | CPP_PP_PROBE_EMPTY()
#define | CPP_PP_PROBE_EMPTY_PROBE_CPP_PP_PROBE_EMPTY CPP_PP_PROBE(~)
#define | CPP_PP_PROBE_N(x, n) x, n,
#define | CPP_PP_RBRACE() }
#define | CPP_PP_RPAREN )
#define | CPP_PP_SECOND(LIST) CPP_PP_SECOND_ LIST
#define | CPP_PP_SECOND_(...) CPP_PP_EXPAND
#define | CPP_requires(NAME, REQS)
#define | CPP_REQUIRES_AUX_(...) { __VA_ARGS__; }
| INTERNAL ONLY.
#define | CPP_requires_ref(NAME, ...) CPP_PP_CAT(NAME, _requires_)<__VA_ARGS__>
#define | CPP_REQUIRES_requires(...) requires(__VA_ARGS__) CPP_REQUIRES_AUX_
| INTERNAL ONLY.
#define | CPP_ret(...) __VA_ARGS__ CPP_RET_AUX_
#define | CPP_RET_AUX_(...) __VA_ARGS__ `
#define | CPP_template(...) template<__VA_ARGS__ CPP_TEMPLATE_AUX_
#define | CPP_TEMPLATE_AUX_(...)
| INTERNAL ONLY. More...
#define | CPP_TEMPLATE_AUX_0(...) __VA_ARGS__`
| INTERNAL ONLY.
#define | CPP_TEMPLATE_AUX_1(DECL, ...) CPP_concept CPP_CONCEPT_NAME_(DECL) = __VA_ARGS__
| INTERNAL ONLY.
#define | CPP_TEMPLATE_AUX_WHICH_(FIRST, ...)
| INTERNAL ONLY. More...
#define | CPP_template_def CPP_template
#define | CPP_template_def_sfinae(...) template<__VA_ARGS__ CPP_TEMPLATE_DEF_SFINAE_AUX_
#define | CPP_TEMPLATE_DEF_SFINAE_AUX_(...)
| INTERNAL ONLY. More...
#define | CPP_TEMPLATE_PROBE_CONCEPT_concept CPP_PP_PROBE(~)
| INTERNAL ONLY.
#define | CPP_template_sfinae(...)
#define | CPP_TEMPLATE_SFINAE_AUX_(...)
| INTERNAL ONLY. More...
#define | CPP_TEMPLATE_SFINAE_AUX_0(...)
| INTERNAL ONLY. More...
#define | CPP_TEMPLATE_SFINAE_AUX_1(DECL, ...)
| INTERNAL ONLY. More...
#define | CPP_TEMPLATE_SFINAE_AUX_3_requires
| INTERNAL ONLY.
#define | CPP_TEMPLATE_SFINAE_AUX_WHICH_(FIRST, ...)
| INTERNAL ONLY. More...
#define | CPP_TEMPLATE_SFINAE_PROBE_CONCEPT_concept CPP_PP_PROBE(~)
| INTERNAL ONLY.
#define | CPP_TRUE_FN CPP_true_fn(::concepts::detail::xNil{})
#define | requires requires `

## Typedefs

template<bool B>
using | concepts::bool_ = std::integral_constant< bool, B >
template<typename T , typename EnableIf >
using | concepts::return_t = meta::invoke< return_t_< EnableIf >, T >
using | concepts::detail::xNil = Nil

## Functions

concept() | concepts::common_reference_with_ (T, U)
concept() | concepts::common_with_ (T, U)
concept() | concepts::copy_assignable_ (T)
concept() | concepts::copy_constructible_ (T)
constexpr bool | concepts::detail::CPP_true_fn (Nil)
concept() | concepts::derived_from_ (T, U)
concept() | concepts::equality_comparable_with_ (T, U)
concept() | concepts::move_assignable_ (T)
template<typename >
constexpr bool | concepts::detail::requires_ ()
concept() | concepts::totally_ordered_with_ (T, U)
template<class >
constexpr bool | concepts::detail::true_ ()

## Variables

template<bool... Bs>
constexpr bool | concepts::and_v
template<typename T , typename U >
concept | concepts::assignable_from
concept() | concepts::assignable_from< T &, T >
concept() | concepts::assignable_from< T &, T const & >
template<typename T , typename U >
concept | concepts::assignable_from__requires_ = CPP_REQUIRES_requires ` (T t, U && u) ( t = (U &&) u, requires_<same_as<T, decltype(t = (U &&) u)>> )
template<typename T >
concept | concepts::detail::boolean_testable_
template<typename T >
concept | concepts::detail::boolean_testable_frag__requires_ = CPP_REQUIRES_requires ` (T && t) ( !(T&&) t, concepts::requires_<boolean_testable_impl_<decltype(!(T&&) t)>> )
template<typename T >
concept | concepts::detail::boolean_testable_impl_ = convertible_to<T, bool>
template<typename T , typename U >
concept | concepts::common_reference_with
template<typename T , typename U >
concept | concepts::common_with
template<typename T , typename... Args>
concept | concepts::constructible_from
template<typename From , typename To >
concept | concepts::convertible_to
concept() | concepts::convertible_to< T const volatile *, U const volatile * >
concept() constructible_from< T, T & > &&constructible_from< T, T const & > &&constructible_from< T, T const > &&convertible_to< T &, T > &&convertible_to< T const &, T > && | concepts::convertible_to< T const, T >
concept() same_as< common_reference_t< T, U >, common_reference_t< U, T > > &&convertible_to< T, common_reference_t< T, U > > && | concepts::convertible_to< U, common_reference_t< T, U > >
template<typename T >
concept | concepts::copy_constructible
template<typename T >
concept | concepts::copyable
template<typename T , typename U >
| concepts::CPP_TEMPLATE_AUX_1
template<typename T , typename U >
| concepts::CPP_TEMPLATE_AUX_1
template<typename T , typename U >
| concepts::CPP_TEMPLATE_AUX_1
template<typename T , typename U >
| concepts::CPP_TEMPLATE_AUX_1
template<typename T , typename U >
| concepts::CPP_TEMPLATE_AUX_1
template<typename T >
| concepts::CPP_TEMPLATE_AUX_1
template<typename T >
| concepts::CPP_TEMPLATE_AUX_1
template<typename T >
| concepts::CPP_TEMPLATE_AUX_1
template<typename T >
concept | concepts::default_constructible
template<typename T , typename U >
concept | concepts::derived_from
template<typename T >
concept | concepts::destructible
template<typename T >
concept | concepts::equality_comparable
template<typename T , typename U >
concept | concepts::equality_comparable_with
template<typename T >
constexpr T | concepts::detail::instance_ = T{}
template<typename T >
concept | concepts::integral
template<bool B>
concept | concepts::is_true = B
template<typename T >
concept | concepts::movable
template<typename T >
concept | concepts::move_constructible
template<bool... Bs>
constexpr bool | concepts::or_v
template<typename T , typename U >
concept | concepts::detail::partially_ordered_with_
template<typename T , typename U >

concept

concepts::detail::partially_ordered_with_frag__requires_ = CPP_REQUIRES_requires ` (detail::as_cref_t<T>& t, detail::as_cref_t<U>& u) ( concepts::requires_<boolean_testable_<decltype(t < u)>>, concepts::requires_<boolean_testable_<decltype(t > u)>>, concepts::requires_<boolean_testable_<decltype(t <= u)>>, concepts::requires_<boolean_testable_<decltype(t >= u)>>, concepts::requires_<boolean_testable_<decltype(u < t)>>, concepts::requires_<boolean_testable_<decltype(u > t)>>, concepts::requires_<boolean_testable_<decltype(u <= t)>>, concepts::requires_<boolean_testable_<decltype(u >= t)>> )

template<typename T >
concept | concepts::regular
template<bool B>
constexpr std::enable_if_t< B, int > | concepts::requires_ = 0
template<typename A , typename B >
concept | concepts::same_as
template<class T , template< typename... > class Trait, typename... Args>
concept | concepts::satisfies
template<typename T >
concept | concepts::semiregular
template<typename T >
concept | concepts::signed_integral
template<typename T >
concept | concepts::swappable
template<typename T >
concept | concepts::swappable__requires_ = CPP_REQUIRES_requires ` (T & t, T & u) ( concepts::swap(t, u) )
template<typename T , typename U >
concept | concepts::swappable_with
template<typename T , typename U >
concept | concepts::swappable_with__requires_ = CPP_REQUIRES_requires ` (T && t, U && u) ( concepts::swap((T &&) t, (T &&) t), concepts::swap((U &&) u, (U &&) u), concepts::swap((U &&) u, (T &&) t), concepts::swap((T &&) t, (U &&) u) )
template<typename T >
concept | concepts::totally_ordered
template<typename T , typename U >
concept | concepts::totally_ordered_with
template<typename... Args>
concept | concepts::type = true
template<typename T >
concept | concepts::unsigned_integral
template<typename T , typename U >
concept | concepts::detail::weakly_equality_comparable_with_
template<typename T , typename U >
concept | concepts::detail::weakly_equality_comparable_with_frag__requires_ = CPP_REQUIRES_requires ` (detail::as_cref_t<T> t, detail::as_cref_t<U> u) ( concepts::requires_<boolean_testable_<decltype(t == u)>>, concepts::requires_<boolean_testable_<decltype(t != u)>>, concepts::requires_<boolean_testable_<decltype(u == t)>>, concepts::requires_<boolean_testable_<decltype(u != t)>> )

## Macro Definition Documentation

## CPP_assert

#define CPP_assert | ( |  | ... | ) |

Value:
static_assert(static_cast<bool>(__VA_ARGS__), \
"Concept assertion failed : " #__VA_ARGS__)

## CPP_AUTO_FUN_DECLTYPE_NOEXCEPT_

#define CPP_AUTO_FUN_DECLTYPE_NOEXCEPT_ | ( |  | ... | ) |

Value:
noexcept(noexcept(decltype(__VA_ARGS__)(__VA_ARGS__))) -> \
decltype(__VA_ARGS__) \
{ return (__VA_ARGS__); }

INTERNAL ONLY.

## CPP_AUTO_FUN_RETURNS_

#define CPP_AUTO_FUN_RETURNS_ | ( |  | ... | ) |

Value:
CPP_PP_EVAL2_( \
CPP_AUTO_FUN_SELECT_RETURNS_, \
(__VA_ARGS__,) \
)(__VA_ARGS__)
CPP_AUTO_FUN_SELECT_RETURNS_
#define CPP_AUTO_FUN_SELECT_RETURNS_(MAYBE_CONST,...)
INTERNAL ONLY.
Definition: concepts.hpp:668

INTERNAL ONLY.

## CPP_AUTO_FUN_RETURNS_CONST_0

#define CPP_AUTO_FUN_RETURNS_CONST_0 | ( |  | ... | ) |

Value:
CPP_PP_EVAL(CPP_AUTO_FUN_DECLTYPE_NOEXCEPT_, \
CPP_PP_CAT(CPP_AUTO_FUN_RETURNS_, __VA_ARGS__))
CPP_AUTO_FUN_RETURNS_
#define CPP_AUTO_FUN_RETURNS_(...)
INTERNAL ONLY.
Definition: concepts.hpp:661
CPP_AUTO_FUN_DECLTYPE_NOEXCEPT_
#define CPP_AUTO_FUN_DECLTYPE_NOEXCEPT_(...)
INTERNAL ONLY.
Definition: concepts.hpp:706

INTERNAL ONLY.

## CPP_AUTO_FUN_SELECT_RETURNS_

#define CPP_AUTO_FUN_SELECT_RETURNS_ | ( |  | MAYBE_CONST,
|  |  | ...
| ) |  |

Value:
CPP_PP_CAT(CPP_AUTO_FUN_RETURNS_CONST_, \
CPP_PP_EVAL(CPP_PP_CHECK, CPP_PP_CAT( \
CPP_PP_PROBE_CONST_MUTABLE_PROBE_, MAYBE_CONST)))

INTERNAL ONLY.

## CPP_CONCEPT_NAME_

#define CPP_CONCEPT_NAME_ | ( |  | DECL | ) |

Value:
CPP_PP_EVAL( \
CPP_PP_CAT, \
CPP_PP_EVAL(CPP_PP_FIRST, CPP_EAT_CONCEPT_(DECL)), _concept_)
CPP_EAT_CONCEPT_
#define CPP_EAT_CONCEPT_(DECL)
INTERNAL ONLY.
Definition: concepts.hpp:325

INTERNAL ONLY.

## CPP_ctor_sfinae

#define CPP_ctor_sfinae | ( |  | TYPE | ) |

Value:
CPP_PP_IGNORE_CXX2A_COMPAT_BEGIN \
TYPE CPP_CTOR_SFINAE_IMPL_1_
CPP_CTOR_SFINAE_IMPL_1_
#define CPP_CTOR_SFINAE_IMPL_1_(...)
INTERNAL ONLY.
Definition: concepts.hpp:359

## CPP_CTOR_SFINAE_IMPL_1_

#define CPP_CTOR_SFINAE_IMPL_1_ | ( |  | ... | ) |

Value:
(__VA_ARGS__ \
CPP_PP_COMMA_IIF( \
CPP_PP_NOT(CPP_PP_IS_NOT_EMPTY(__VA_ARGS__))) \
CPP_CTOR_SFINAE_REQUIRES

INTERNAL ONLY.

## CPP_CTOR_SFINAE_REQUIRES

#define CPP_CTOR_SFINAE_REQUIRES | ( |  | ... | ) |

Value:
CPP_PP_CAT( \
CPP_CTOR_SFINAE_REQUIRES_, \
CPP_PP_EVAL( \
CPP_PP_CHECK, \
CPP_CTOR_SFINAE_MAKE_PROBE(__VA_ARGS__,)))(__VA_ARGS__)
CPP_CTOR_SFINAE_MAKE_PROBE
#define CPP_CTOR_SFINAE_MAKE_PROBE(FIRST,...)
INTERNAL ONLY.
Definition: concepts.hpp:370

INTERNAL ONLY.

## CPP_CTOR_SFINAE_REQUIRES_0

#define CPP_CTOR_SFINAE_REQUIRES_0 | ( |  | ... | ) |

Value:
std::enable_if_t< \
CPP_PP_CAT(CPP_TEMPLATE_SFINAE_AUX_3_, __VA_ARGS__) && CPP_TRUE_FN, \
::concepts::detail::Nil \
> = {}) \
CPP_PP_IGNORE_CXX2A_COMPAT_END
concepts::detail::Nil
Definition: concepts.hpp:777

INTERNAL ONLY.

## CPP_CTOR_SFINAE_REQUIRES_1

#define CPP_CTOR_SFINAE_REQUIRES_1 | ( |  | ... | ) |

Value:
std::enable_if_t< \
CPP_PP_EVAL(CPP_PP_CAT, \
CPP_TEMPLATE_SFINAE_AUX_3_, \
CPP_PP_CAT(CPP_CTOR_SFINAE_EAT_NOEXCEPT_, __VA_ARGS__)) && CPP_TRUE_FN,\
::concepts::detail::Nil \
> = {}) \
CPP_PP_EXPAND(CPP_PP_CAT(CPP_CTOR_SFINAE_SHOW_NOEXCEPT_, __VA_ARGS__)))

INTERNAL ONLY.

## CPP_CTOR_SFINAE_SHOW_NOEXCEPT_noexcept

#define CPP_CTOR_SFINAE_SHOW_NOEXCEPT_noexcept | ( |  | ... | ) |

Value:
noexcept(__VA_ARGS__) \
CPP_PP_IGNORE_CXX2A_COMPAT_END \
CPP_PP_EAT CPP_PP_LPAREN

INTERNAL ONLY.

## CPP_FUN_IMPL_1_

#define CPP_FUN_IMPL_1_ | ( |  | ... | ) |

Value:
(__VA_ARGS__) \
CPP_FUN_IMPL_2_

INTERNAL ONLY.

## CPP_PP_COUNT

#define CPP_PP_COUNT | ( |  | ... | ) |

Value:
CPP_PP_EXPAND(CPP_PP_COUNT_(__VA_ARGS__, \
50, 49, 48, 47, 46, 45, 44, 43, 42, 41, \
40, 39, 38, 37, 36, 35, 34, 33, 32, 31, \
30, 29, 28, 27, 26, 25, 24, 23, 22, 21, \
20, 19, 18, 17, 16, 15, 14, 13, 12, 11, \
10, 9, 8, 7, 6, 5, 4, 3, 2, 1,))

## CPP_PP_IS_NOT_EMPTY

#define CPP_PP_IS_NOT_EMPTY | ( |  | ... | ) |

Value:
CPP_PP_EVAL( \
CPP_PP_CHECK, \
CPP_PP_CAT( \
CPP_PP_PROBE_EMPTY_PROBE_, \
CPP_PP_PROBE_EMPTY __VA_ARGS__ ()))

## CPP_requires

#define CPP_requires | ( |  | NAME,
|  |  | REQS
| ) |  |

Value:
CPP_concept CPP_PP_CAT(NAME, _requires_) = \
CPP_PP_CAT(CPP_REQUIRES_, REQS)

## CPP_TEMPLATE_AUX_

#define CPP_TEMPLATE_AUX_ | ( |  | ... | ) |

Value:
> CPP_PP_CAT( \
CPP_TEMPLATE_AUX_, \
CPP_TEMPLATE_AUX_WHICH_(__VA_ARGS__,))(__VA_ARGS__)
CPP_TEMPLATE_AUX_WHICH_
#define CPP_TEMPLATE_AUX_WHICH_(FIRST,...)
INTERNAL ONLY.
Definition: concepts.hpp:228
CPP_TEMPLATE_AUX_
#define CPP_TEMPLATE_AUX_(...)
INTERNAL ONLY.
Definition: concepts.hpp:222

INTERNAL ONLY.

## CPP_TEMPLATE_AUX_WHICH_

#define CPP_TEMPLATE_AUX_WHICH_ | ( |  | FIRST,
|  |  | ...
| ) |  |

Value:
CPP_PP_EVAL( \
CPP_PP_CHECK, \
CPP_PP_CAT(CPP_TEMPLATE_PROBE_CONCEPT_, FIRST))

INTERNAL ONLY.

## CPP_TEMPLATE_DEF_SFINAE_AUX_

#define CPP_TEMPLATE_DEF_SFINAE_AUX_ | ( |  | ... | ) |

Value:
, \
bool CPP_true, \
std::enable_if_t< \
CPP_PP_CAT(CPP_TEMPLATE_SFINAE_AUX_3_, __VA_ARGS__) && \
CPP_BOOL(CPP_true), \
int>>

INTERNAL ONLY.

## CPP_template_sfinae

#define CPP_template_sfinae | ( |  | ... | ) |

Value:
CPP_PP_IGNORE_CXX2A_COMPAT_BEGIN \
template<__VA_ARGS__ CPP_TEMPLATE_SFINAE_AUX_
CPP_TEMPLATE_SFINAE_AUX_
#define CPP_TEMPLATE_SFINAE_AUX_(...)
INTERNAL ONLY.
Definition: concepts.hpp:288

## CPP_TEMPLATE_SFINAE_AUX_

#define CPP_TEMPLATE_SFINAE_AUX_ | ( |  | ... | ) |

Value:
CPP_PP_CAT( \
CPP_TEMPLATE_SFINAE_AUX_, \
CPP_TEMPLATE_SFINAE_AUX_WHICH_(__VA_ARGS__,))(__VA_ARGS__)
CPP_TEMPLATE_SFINAE_AUX_WHICH_
#define CPP_TEMPLATE_SFINAE_AUX_WHICH_(FIRST,...)
INTERNAL ONLY.
Definition: concepts.hpp:282

INTERNAL ONLY.

## CPP_TEMPLATE_SFINAE_AUX_0

#define CPP_TEMPLATE_SFINAE_AUX_0 | ( |  | ... | ) |

Value:
, \
bool CPP_true = true, \
std::enable_if_t< \
CPP_PP_CAT(CPP_TEMPLATE_SFINAE_AUX_3_, __VA_ARGS__) && \
CPP_BOOL(CPP_true), \
int> = 0> \
CPP_PP_IGNORE_CXX2A_COMPAT_END

INTERNAL ONLY.

## CPP_TEMPLATE_SFINAE_AUX_1

#define CPP_TEMPLATE_SFINAE_AUX_1 | ( |  | DECL,
|  |  | ...
| ) |  |

Value:
, \
bool CPP_true = true, \
std::enable_if_t<__VA_ARGS__ && CPP_BOOL(CPP_true), int> = 0> \
auto CPP_CONCEPT_NAME_(DECL)( \
::concepts::detail::tag<CPP_CONCEPT_PARAMS_(DECL)>*) \
-> char(&)[1]; \
auto CPP_CONCEPT_NAME_(DECL)(...) -> char(&)[2] \
CPP_PP_IGNORE_CXX2A_COMPAT_END
CPP_CONCEPT_NAME_
#define CPP_CONCEPT_NAME_(DECL)
INTERNAL ONLY.
Definition: concepts.hpp:315
CPP_CONCEPT_PARAMS_
#define CPP_CONCEPT_PARAMS_(DECL)
INTERNAL ONLY.
Definition: concepts.hpp:321
concepts::detail::tag
Definition: concepts.hpp:765

INTERNAL ONLY.

## CPP_TEMPLATE_SFINAE_AUX_WHICH_

#define CPP_TEMPLATE_SFINAE_AUX_WHICH_ | ( |  | FIRST,
|  |  | ...
| ) |  |

Value:
CPP_PP_EVAL( \
CPP_PP_CHECK, \
CPP_PP_CAT(CPP_TEMPLATE_SFINAE_PROBE_CONCEPT_, FIRST))

INTERNAL ONLY.

## Variable Documentation

## and_v

template<bool... Bs>

constexpr bool concepts::and_v

constexpr

Initial value:
=
std::is_same< detail::bools<Bs..., true>, detail::bools<true, Bs...> >::value

## assignable_from

template<typename T , typename U >

concept concepts::defs::assignable_from

Initial value:
=
std::is_lvalue_reference<T>::value &&
common_reference_with<detail::as_cref_t<T>, detail::as_cref_t<U>> &&
defs::assignable_from__requires_ < T, U >

## boolean_testable_

template<typename T >

concept concepts::detail::boolean_testable_

Initial value:
=
boolean_testable_frag__requires_ < T > &&
boolean_testable_impl_<T>

## common_reference_with

template<typename T , typename U >

concept concepts::defs::common_reference_with

Initial value:
=
concepts::common_reference_with__concept_ < T, U >

## common_with

template<typename T , typename U >

concept concepts::defs::common_with

Initial value:
=
concepts::common_with__concept_ < T, U >

## constructible_from

template<typename T , typename... Args>

concept concepts::defs::constructible_from

Initial value:
=
destructible<T> &&
std::is_constructible< T, Args... >::value

## convertible_to

template<typename From , typename To >

concept concepts::defs::convertible_to

Initial value:
=
implicitly_convertible_to<From, To> &&
explicitly_convertible_to<From, To>

## copy_constructible

template<typename T >

concept concepts::defs::copy_constructible

Initial value:
=
move_constructible<T> &&
concepts::copy_constructible__concept_ < T >

## copyable

template<typename T >

concept concepts::defs::copyable

Initial value:
=
copy_constructible<T> &&
movable<T> &&
concepts::copy_assignable__concept_ < T >

## default_constructible

template<typename T >

concept concepts::defs::default_constructible

Initial value:
=
constructible_from<T>

## derived_from

template<typename T , typename U >

concept concepts::defs::derived_from

Initial value:
=
std::is_base_of< U, T >::value &&
concepts::derived_from__concept_ < T, U >

## destructible

template<typename T >

concept concepts::defs::destructible

Initial value:
=
std::is_nothrow_destructible<T>::value

## equality_comparable

template<typename T >

concept concepts::defs::equality_comparable

Initial value:
=
detail::weakly_equality_comparable_with_<T, T>

## equality_comparable_with

template<typename T , typename U >

concept concepts::defs::equality_comparable_with

Initial value:
=
equality_comparable<T> &&
equality_comparable<U> &&
detail::weakly_equality_comparable_with_<T, U> &&
common_reference_with<detail::as_cref_t<T>, detail::as_cref_t<U>> &&
concepts::equality_comparable_with__concept_ < T, U >

## integral

template<typename T >

concept concepts::defs::integral

Initial value:
=
std::is_integral<T>::value

## movable

template<typename T >

concept concepts::defs::movable

Initial value:
=
std::is_object<T>::value &&
move_constructible<T> &&
concepts::move_assignable__concept_ < T > &&
swappable<T>

## move_constructible

template<typename T >

concept concepts::defs::move_constructible

Initial value:
=
constructible_from<T, T> &&
convertible_to<T, T>

## or_v

template<bool... Bs>

constexpr bool concepts::or_v

constexpr

Initial value:
=
!std::is_same< detail::bools<Bs..., false>, detail::bools<false, Bs...> >::value

## partially_ordered_with_

template<typename T , typename U >

concept concepts::detail::partially_ordered_with_

Initial value:
=
partially_ordered_with_frag__requires_ < T, U >

## regular

template<typename T >

concept concepts::defs::regular

Initial value:
=
semiregular<T> &&
equality_comparable<T>

## same_as

template<typename A , typename B >

concept concepts::defs::same_as

Initial value:
=
std::is_same< A, B >::value && std::is_same< B, A >::value

## satisfies

template<class T , template< typename... > class Trait, typename... Args>

concept concepts::defs::satisfies

Initial value:
=
static_cast<bool>(Trait<T, Args...>::type::value)

## semiregular

template<typename T >

concept concepts::defs::semiregular

Initial value:
=
copyable<T> &&
default_constructible<T>

## signed_integral

template<typename T >

concept concepts::defs::signed_integral

Initial value:
=
integral<T> &&
std::is_signed<T>::value

## swappable

template<typename T >

concept concepts::defs::swappable

Initial value:
=
defs::swappable__requires_ < T >

## swappable_with

template<typename T , typename U >

concept concepts::defs::swappable_with

Initial value:
=
common_reference_with<detail::as_cref_t<T>, detail::as_cref_t<U>> &&
defs::swappable_with__requires_ < T, U >

## totally_ordered

template<typename T >

concept concepts::defs::totally_ordered

Initial value:
=
equality_comparable<T> &&
detail::partially_ordered_with_<T, T>

## totally_ordered_with

template<typename T , typename U >

concept concepts::defs::totally_ordered_with

Initial value:
=
totally_ordered<T> &&
totally_ordered<U> &&
equality_comparable_with<T, U> &&
concepts::totally_ordered_with__concept_ < T, U >

## unsigned_integral

template<typename T >

concept concepts::defs::unsigned_integral

Initial value:
=
integral<T> &&
!signed_integral<T>

## weakly_equality_comparable_with_

template<typename T , typename U >

concept concepts::detail::weakly_equality_comparable_with_

Initial value:
=
weakly_equality_comparable_with_frag__requires_ < T, U >